<?php



if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('Wcap_Actions_Handler' ) ) {

    
    class Wcap_Actions_Handler{

        
        function wcap_delete_bulk_action_handler_function( $abandoned_cart_id, $count ) {
            global $wpdb;
            $get_user_id         = "SELECT user_id FROM `" . WCAP_ABANDONED_CART_HISTORY_TABLE . "` WHERE id = '$abandoned_cart_id' ";
            $results_get_user_id = $wpdb->get_results( $get_user_id );
            $user_id_of_guest    = $results_get_user_id[0]->user_id;

            $query_delete        = "DELETE FROM `" . WCAP_ABANDONED_CART_HISTORY_TABLE . "` WHERE id = '$abandoned_cart_id' ";
            $results_delete      = $wpdb->get_results( $query_delete );

            if ( $user_id_of_guest >= '63000000' ) {
                $guest_query_delete   = "DELETE FROM `" . WCAP_GUEST_CART_HISTORY_TABLE . "` WHERE id = '" . $user_id_of_guest . "'";
                $results_guest = $wpdb->get_results( $guest_query_delete );
                //guest user
            }

            $query_delete_sent_history        = "DELETE FROM `" . WCAP_EMAIL_SENT_HISTORY_TABLE . "` WHERE abandoned_order_id = '$abandoned_cart_id' ";
            $results_delete_sent_history      = $wpdb->get_results( $query_delete_sent_history );

            $wcap_get_post_meta_of_ac_id = get_post_meta ( $abandoned_cart_id, 'wcap_atc_report' );
            if ( is_array( $wcap_get_post_meta_of_ac_id ) && count( $wcap_get_post_meta_of_ac_id ) > 0 ){
                delete_post_meta ( $abandoned_cart_id, 'wcap_atc_report' );
            }

            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=listcart&wcap_section=wcap_trash_abandoned&wcap_deleted=YES&wcap_count=$count" ) );
        }

        

        function wcap_delete_template_bulk_action_handler_function( $template_id ) {
            global $wpdb;
            $id_remove    = $template_id;
            $query_remove = "DELETE FROM `" . WCAP_EMAIL_TEMPLATE_TABLE . "` WHERE id='" . $id_remove . "' ";
            $wpdb->query( $query_remove );

            wp_safe_redirect( admin_url( '/admin.php?page=xcart&action=cart_recovery&section=emailtemplates&wcap_template_deleted=YES' ) );
        }

        
        public static function wcap_delete_abandoned_carts_after_x_days() {
            global $wpdb;
            
            $delete_ac_after_days      = get_option( 'ac_delete_abandoned_order_days' );
            
            if( '' != $delete_ac_after_days && 0 != $delete_ac_after_days ) {
            
                $delete_ac_after_days_time = $delete_ac_after_days * 86400;
                $current_time              = current_time( 'timestamp' );
                $check_time                = $current_time - $delete_ac_after_days_time;
            
                $query = "SELECT * FROM `" . WCAP_ABANDONED_CART_HISTORY_TABLE . "` WHERE recovered_cart = '0' AND abandoned_cart_time < %s";
                $carts = $wpdb->get_results ( $wpdb->prepare( $query, $check_time ) );
            
                foreach( $carts as $cart_key => $cart_value ) {
                    self::delete_ac_carts( $cart_value );
                }
            }

            
            $blank_cart_info   = "'{\"cart\":[],\"shipping_charges\":0}', '{\"cart\":[]}'";
            $delete_empty = "DELETE FROM `" . WCAP_ABANDONED_CART_HISTORY_TABLE . "` WHERE abandoned_cart_info IN (" . stripslashes( $blank_cart_info ) . ")";
            $wpdb->query( $delete_empty );
            
        }

        
        public static function wcap_delete_coupon_codes_after_x_days() {
            $wcap_ajax = new Wcap_Ajax();
            $wcap_ajax::wcap_delete_expired_used_coupon_code();
        }

        
        public static function delete_ac_carts( $value ) {
            global $wpdb;

            $abandoned_id = isset( $value->id ) ? $value->id : 0;
            $user_id      = isset( $value->user_id ) ? $value->user_id : 0;
            $user_type    = isset( $value->user_type ) ? $value->user_type : '';
            
            if( $abandoned_id > 0 && '' != $user_type ) {
                
                $query_delete_sent_history   = $wpdb->delete( WCAP_EMAIL_SENT_HISTORY_TABLE, array( 'abandoned_order_id' => $abandoned_id ) );
            
                
                $query_delete_cart     = $wpdb->delete( $wpdb->prefix ."usermeta", array( 'user_id' => $user_id, 'meta_key' => '_woocommerce_persistent_cart' ) );
            
                
                $query                 = $wpdb->delete( WCAP_ABANDONED_CART_HISTORY_TABLE, array( 'user_id' => $user_id, 'id' => $abandoned_id ) );
            
                
                if ( 'GUEST' == $user_type && $user_id >= 63000000 ) {
                    $guest_query   = $wpdb->delete( WCAP_GUEST_CART_HISTORY_TABLE, array( 'id' => $user_id ) );
                }

                
                $get_templates = $wpdb->get_col( "SELECT template_id FROM " . WCAP_NOTIFICATIONS_META . " WHERE meta_key = 'to_be_sent_cart_ids'" );

                if( is_array( $get_templates ) && count( $get_templates ) > 0 ) {
                    foreach( $get_templates as $template_id ) {
                        wcap_update_meta( $template_id, $abandoned_id );
                    }
                }
            }
        }

        
        function wcap_recovered_delete_bulk_action_handler( $abandoned_cart_id ) {
            global $wpdb;
            $get_user_id         = "SELECT user_id FROM `" . WCAP_ABANDONED_CART_HISTORY_TABLE . "` WHERE id = '$abandoned_cart_id' ";
            $results_get_user_id = $wpdb->get_results( $get_user_id );
            $user_id_of_guest    = $results_get_user_id[0]->user_id;

            $query_delete        = "DELETE FROM `" . WCAP_ABANDONED_CART_HISTORY_TABLE . "` WHERE id = '$abandoned_cart_id' ";
            $results_delete      = $wpdb->get_results( $query_delete );

            if ( $user_id_of_guest >= '63000000' ) {
                $guest_query_delete   = "DELETE FROM `" . WCAP_GUEST_CART_HISTORY_TABLE . "` WHERE id = '" . $user_id_of_guest . "'";
                $results_guest = $wpdb->get_results( $guest_query_delete );
            }

            $query_delete_sent_history        = "DELETE FROM `" . WCAP_EMAIL_SENT_HISTORY_TABLE . "` WHERE abandoned_order_id = '$abandoned_cart_id' ";
            $results_delete_sent_history      = $wpdb->get_results( $query_delete_sent_history );

            wp_safe_redirect( admin_url( '/admin.php?page=xcart&action=stats&wcap_rec_deleted=YES' ) );
        }

        
        function wcap_recovered_trash_bulk_action_handler( $abandoned_cart_id, $count ) {
            global $wpdb;
            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '1' ),
                           array( 'id'         => $abandoned_cart_id )
                         );

            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=stats&wcap_section=wcap_all_rec&wcap_rec_trash=YES&wcap_count=$count" ) );
        }

        
        function wcap_recovered_restore_bulk_action_handler( $abandoned_cart_id, $count ) {
            global $wpdb;

            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '' ),
                           array( 'id'         => $abandoned_cart_id )
                         );

            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=stats&wcap_section=wcap_trash_rec&wcap_rec_restore=YES&wcap_count=$count" ) );
        }

        
        function wcap_abandoned_trash_bulk_action_handler( $abandoned_cart_id, $count ) {
            global $wpdb;
            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '1' ),
                           array( 'id'         => $abandoned_cart_id )
                         );

            
            Wcap_Common::wcap_delete_cart_notification( $abandoned_cart_id );
            
            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=listcart&wcap_abandoned_trash=YES&wcap_count=$count" ) );
        }
        
        
        function wcap_abandoned_trash_visitor_bulk_action_handler() {
            global $wpdb;
            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '1' ),
                           array( 'user_id'    => 0 )
                         );

            
            $get_visitors = $wpdb->get_col( 'SELECT id FROM ' . WCAP_ABANDONED_CART_HISTORY_TABLE . " WHERE wcap_trash = '1' AND user_id = 0" );

            if ( is_array( $get_visitors ) && count( $get_visitors ) > 0 ) {
                foreach ( $get_visitors as $abandoned_cart_id ) {
                    Wcap_Common::wcap_delete_cart_notification( $abandoned_cart_id );
                }
            }
            
            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=listcart&wcap_abandoned_trash_visitor=YES" ) );
        }
        
        
        function wcap_abandoned_trash_guest_bulk_action_handler() {
            global $wpdb;
            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '1' ),
                           array( 'user_type'  => 'GUEST' )
                         );

            
            $get_guests = $wpdb->get_col( 'SELECT id FROM ' . WCAP_ABANDONED_CART_HISTORY_TABLE . " WHERE wcap_trash = '1' AND user_type = 'GUEST'" );

            if ( is_array( $get_guests ) && count( $get_guests ) > 0 ) {
                foreach ( $get_guests as $abandoned_cart_id ) {
                    Wcap_Common::wcap_delete_cart_notification( $abandoned_cart_id );
                }
            }
            
            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=listcart&wcap_abandoned_trash_guest=YES" ) );
        }

        
        function wcap_abandoned_trash_registered_bulk_action_handler() {
            global $wpdb;
            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '1' ),
                           array( 'user_type'  => 'REGISTERED' )
                         );

            
            $get_registered = $wpdb->get_col( 'SELECT id FROM ' . WCAP_ABANDONED_CART_HISTORY_TABLE . " WHERE wcap_trash = '1' AND user_type = 'REGISTERED'" );

            if ( is_array( $get_registered ) && count( $get_registered ) > 0 ) {
                foreach ( $get_registered as $abandoned_cart_id ) {
                    Wcap_Common::wcap_delete_cart_notification( $abandoned_cart_id );
                }
            }
            
            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=listcart&wcap_abandoned_trash_registered=YES" ) );
        }

        
        function wcap_abandoned_trash_all_bulk_action_handler() {
            global $wpdb;

            $wpdb->query( 'UPDATE ' . WCAP_ABANDONED_CART_HISTORY_TABLE . " SET wcap_trash = '1'" );
            
            
            $get_all = $wpdb->get_col( 'SELECT id FROM ' . WCAP_ABANDONED_CART_HISTORY_TABLE . " WHERE wcap_trash = '1'" );

            if ( is_array( $get_all ) && count( $get_all ) > 0 ) {
                foreach ( $get_all as $abandoned_cart_id ) {
                    Wcap_Common::wcap_delete_cart_notification( $abandoned_cart_id );
                }
            }
            
            wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=listcart&wcap_abandoned_trash_all=YES" ) );
        }

        
        function wcap_abandoned_restore_bulk_action_handler( $abandoned_cart_id, $count ) {
            global $wpdb;
            $wpdb->update( WCAP_ABANDONED_CART_HISTORY_TABLE,
                           array( 'wcap_trash' => '' ),
                           array( 'id'         => $abandoned_cart_id )
                         );

            $query      = "SELECT COUNT(id) FROM `".WCAP_ABANDONED_CART_HISTORY_TABLE."` WHERE wcap_trash = '1'";
            $results    = $wpdb->get_results( $query );
            $link       = ( $results[0]->{'COUNT(id)'} > 0 ) ? "/admin.php?page=xcart&action=listcart&wcap_section=wcap_trash_abandoned&wcap_abandoned_restore=YES&wcap_count=$count" : "/admin.php?page=xcart&action=listcart&wcap_abandoned_restore=YES&wcap_count=$count";
            wp_safe_redirect( admin_url( $link ) );
        }
    }
}
