<?php



if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('Wcap_EDD' ) ) {
    
    class Wcap_EDD{

        
        public static function wcap_edd_ac_register_option() {
            
            register_setting( 'edd_sample_license', 'edd_sample_license_key_ac_woo', array( 'Wcap_EDD', 'wcap_edd_sanitize_license' ) );
        }

        
        public static function wcap_edd_sanitize_license( $new ) {
            $old = get_option( 'edd_sample_license_key_ac_woo' );
            if ( $old && $old != $new ) {
                delete_option( 'edd_sample_license_status_ac_woo' ); 
            }
            return $new;
        }

        
        public static function wcap_edd_ac_activate_license() {
            
            if ( isset( $_POST['edd_ac_license_activate'] ) ) {
                
                if ( ! check_admin_referer( 'edd_sample_nonce', 'edd_sample_nonce' ) )
                    return; 
                
                $license = trim( get_option( 'edd_sample_license_key_ac_woo' ) );
                
                $api_params = array(
                        'edd_action'=> 'activate_license',
                        'license'   => $license,
                        'item_name' => urlencode( EDD_SL_ITEM_NAME_AC_WOO ) 
                );
                
                $response = wp_remote_get( add_query_arg( $api_params, EDD_SL_STORE_URL_AC_WOO ), array( 'timeout' => 15, 'sslverify' => false ) );
                
                if ( is_wp_error( $response ) )
                    return false;
                
                $license_data = json_decode( wp_remote_retrieve_body( $response ) );
                
                update_option( 'edd_sample_license_status_ac_woo', $license_data->license );
            }
        }

        
        public static    function wcap_edd_ac_deactivate_license() {
            
            if ( isset( $_POST['edd_ac_license_deactivate'] ) ) {
                
                if ( ! check_admin_referer( 'edd_sample_nonce', 'edd_sample_nonce' ) )
                    return; 
                
                $license = trim( get_option( 'edd_sample_license_key_ac_woo' ) );
                
                $api_params = array(
                        'edd_action'=> 'deactivate_license',
                        'license'   => $license,
                        'item_name' => urlencode( EDD_SL_ITEM_NAME_AC_WOO ) 
                );
                
                $response = wp_remote_get( add_query_arg( $api_params, EDD_SL_STORE_URL_AC_WOO ), array( 'timeout' => 15, 'sslverify' => false ) );
                
                if ( is_wp_error( $response ) )
                    return false;
                
                $license_data = json_decode( wp_remote_retrieve_body( $response ) );
                
                if ( $license_data->license == 'deactivated' )
                    delete_option( 'edd_sample_license_status_ac_woo' );
            }
        }

        
        public static    function edd_sample_check_license() {
            global $wp_version;
            $license = trim( get_option( 'edd_sample_license_key_ac_woo' ) );
            $api_params = array(
                    'edd_action' => 'check_license',
                    'license'    => $license,
                    'item_name'  => urlencode( EDD_SL_ITEM_NAME_AC_WOO )
            );
            
            $response = wp_remote_get( add_query_arg( $api_params, EDD_SL_STORE_URL_AC_WOO ), array( 'timeout' => 15, 'sslverify' => false ) );
            if ( is_wp_error( $response ) )
                return false;
            $license_data = json_decode( wp_remote_retrieve_body( $response ) );
            if ( $license_data->license == 'valid' ) {
                echo 'valid';
                exit;
                
            } else {
                echo 'invalid';
                exit;
                
            }
        }

        
        public static function wcap_edd_get_license_status() {
            return get_option( 'edd_sample_license_status_ac_woo' );
        }


    }
}
