<?php


if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('Wcap_SMS' ) ) {

    
    class Wcap_SMS{
    
        public function __construct() {
        }
        
        
        static function cart_recovery_views() {
            
            $email_class = '';
            $sms_class = '';
            
            $section = isset( $_GET[ 'section' ] ) ? $_GET[ 'section' ] : '';
            
            switch( $section ) {
                case '':
                case 'emailtemplates':
                    $email_class = 'current';
                    break;
                case 'sms':
                    $sms_class = 'current';
                    break;
            }
            
            ?>
            <ul class="subsubsub">
                <li><a href="admin.php?page=xcart&action=cart_recovery&section=emailtemplates" class="<?php echo $email_class; ?>"><?php _e( 'Email Templates', 'xcart-tr' );?></a></li> | 
                <li><a href="admin.php?page=xcart&action=cart_recovery&section=sms" class="<?php echo $sms_class; ?>"><?php _e( 'تنظیمات', 'xcart-tr' ); ?></a></li>            
            </ul>
            <br class="clear">
            <?php 
        }
        
        
        static function display_sms_list() {
            
            //Wcap_SMS::cart_recovery_views();
            $new_id = Wcap_SMS::get_new_id();
            
            ?>

            <p><?php _e( "<b>نکته:</b> جهت ویرایش متن پیام، بر روی آن پیام کلیک کنید.", 'xcart-tr' ); ?></p>
            
             <div id="merge_tags" style="display: block !important; background: white; float: right; width: 100%; border-radius: 10px; box-shadow: 1px 2px 3px 1px #dbdbdb !important;padding: 20px;">
                    <p >
                        <b><?php _e( 'راهنمای تنظیمات متن پیامک', 'xcart-tr' );?></b>
                        <br><br>
                        <p><?php _e( 'دقت داشته باشید در هنگام استفاده از شورت کد‌ها در متن پیامک حتما شورت کد در داخل {{}} قرار گیرد.', 'xcart-tr' );?><br><br>
                        {{user.name}} - <?php _e( 'نام کاربر', 'xcart-tr' );?> <br>
                        {{date.abandoned}} - <?php _e( 'تاریخ ایجاد سبد خرید رها شده', 'xcart-tr' );?><br>
                        {{coupon.code}} - <?php _e( 'کد تخفیف', 'xcart-tr' );?> <br>
                        {{checkout.link}} - <?php _e( 'لینک صفحه پرداخت سفارش مشتری', 'xcart-tr' );?><br>
                        </p>
                    </p>
                </div>
            
            <div >
                <p style="float:left;">
                    <a cursor: pointer; href="javascript:void(0)" class="button-secondary" id="new_sms" ><?php _e( 'اضافه کردن پیامک جدید', 'xcart-tr' ); ?></a>
					<input type='hidden' id='new_template_id' value='<?php echo $new_id;?>' />
					<?php 
					$defaults = Wcap_SMS::wcap_create_defaults();
					Wcap_SMS::wcap_add_defaults( $defaults ); ?>
                </p>
                <?php

                $sms_list = new Wcap_SMS_Templates();
                $sms_list->wcap_sms_templates_prepare_items();
                ?>
                <div class="wrap">
                    <form id="wcap-sms-templates" method="get" >
                        <input type="hidden" name="page" value="xcart" />
                        <input type="hidden" name="action" value="cart_recovery" />
                        <input type="hidden" name="section" value="sms" />
                        <?php $sms_list->display(); ?>
                    </form>
                </div>
            	        
            </div>
          
            <?php
                        
        }
        
        
		static function wcap_create_defaults() {

		    
		    $new_id = Wcap_SMS::get_new_id();
			$default_sms_obj = new Wcap_SMS_Templates();

			$columns = $default_sms_obj->get_columns();
			$hidden = $default_sms_obj->wcap_hidden_sms_cols();
			
			$defaults = array();
			
			
			$default_sms_values = (object) array( 
			    'id'             => $new_id,
			    'updated'        => 1,
			    'txt_msg'        => '',
			    'full_txt_msg'   => '',
			    'coupon_code'    => '',
			    'sent_time'      => '1 minutes',
			    'sms_sent'       => 0,
			    'active'       => 'on'
			);
            
			foreach( $columns as $col_name => $col_desc ) {
			    
			    
			    $class = "class='$col_name column-$col_name'";
			    $style = ( in_array( $col_name, $hidden ) ) ? " style='display:none;'" : ''; 
			    $attributes = $class . $style;
			    	
				switch( $col_name ) {
					case 'cb':
						$value = "<th scope='row' class='check-column'><input name='template_id[]' value= '$new_id' type='checkbox'></th>"; 
						break;
					case 'id':
					    $value = "<td $attributes>";
					    $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>";
					    break;
				    case 'updated':
				        $value = "<td $attributes>";
				        $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>";
				        break;
					case 'txt_msg': 
	                    $value = "<td $attributes><textarea class='msg' rows='4'>";
	                    $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</textarea></td>"; 
	                    break;
	                case 'full_txt_msg': 
	                    $value = "<td $attributes>";
                        $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>"; 
	                    break;
                    case 'coupon_code':
                        $value = "<td $attributes>";
                        $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>";
                        break;
	                case 'sent_time': 
	                    $value = "<td $attributes>";
	                    $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>"; 
	                    break;
	                case 'sms_sent': 
	                    $value = "<td $attributes>";
	                    $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>";
	                    break;
	                case "activate": 
	                    $value = "<td $attributes>";
	                    $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>"; 
	                    break;
                    case "actions":
                        $value = "<td $attributes>";
                        $value .= $default_sms_obj->column_default( $default_sms_values, $col_name ) . "</td>";
                        break;
				}
				$defaults[ $col_name ] = $value;
			}
			
			return $defaults;
		}
		
		
		static function get_new_id() {
		    
		    global $wpdb;
		    
		    $max_id = $wpdb->get_results( "SELECT MAX(ID) as maxID FROM " . WCAP_NOTIFICATIONS );
		    $new_id = isset( $max_id[0]->maxID ) ? $max_id[0]->maxID + 1 : 1;
		    
		    return $new_id;
		}
		
		
		static function wcap_add_defaults( $defaults ) {
		    
		    foreach( $defaults as $col_name => $default_value ) {
		        ?>
		        
		        <input type="hidden" id="<?php echo $col_name . '_default' ?>" value="<?php echo $default_value; ?>" />
		        <?php
		    }
		}
		
		
        public static function wcap_delete_sms() {
            
            $template_id = isset( $_POST[ 'template_id' ] ) ? $_POST[ 'template_id' ] : 0;
            
            if( $template_id > 0 ) {
                self:: wcap_delete_template_data( $template_id );
            }
            die();
        }

        
        static function wcap_delete_template_data( $template_id ) {
            global $wpdb;
        
            
            $wpdb->delete( WCAP_NOTIFICATIONS_META, array( 'template_id' => $template_id ) );
        
            
            $wpdb->delete( WCAP_NOTIFICATIONS, array( 'id' => $template_id ) );
        }
        
        
        static function wcap_save_bulk_sms() {
            
            global $wpdb;
            
            $clean_template_data = new stdClass();
            if ( isset( $_POST[ 'template_data' ] ) ) {
                $post_templates = $_POST[ 'template_data' ];
                $tempData = stripslashes( $post_templates );
                $clean_template_data = json_decode($tempData);
            }
            
            $insert = false;
            if ( $clean_template_data != false && count( get_object_vars( $clean_template_data ) ) > 0 ) {
                foreach( $clean_template_data as $id => $data ) {
                    
                    
                    $template_details = $wpdb->get_results( $wpdb->prepare( "SELECT ID FROM " . WCAP_NOTIFICATIONS . " WHERE ID = %d", $id ) );
                    $template_present = ( isset( $template_details[0]->ID ) ) ? true : false;
                     
                    $data_entries = explode( '|~|', $data );
                    
                    $sms_body = isset( $data_entries[0] ) ? $data_entries[0] : '';
                    $frequency = isset( $data_entries[1] ) ? $data_entries[1] : '';
                    $active = ( isset( $data_entries[2] ) && $data_entries[2] == 'on' ) ? 1 : 0;
                    $coupon_code = isset( $data_entries[3] ) && $data_entries[3] > 0 ? $data_entries[3] : '';
                    $default_template = isset( $data_entries[4] ) ? $data_entries[4] : 0;
                    
                    
                    if( $active == 1 ) {
                        
                        $get_temp = "SELECT id FROM " . WCAP_NOTIFICATIONS . "
                                        WHERE type = 'sms'
                                        AND frequency = %s
                                        AND is_active = '1'";
                    
                        $result_templates = $wpdb->get_results( $wpdb->prepare( $get_temp, $frequency ) );
                    
                        
                        if( is_array( $result_templates ) && count( $result_templates ) > 0 ) {
                    
                            $wpdb->update( WCAP_NOTIFICATIONS, array( 'is_active' => 0 ), array( 'type' => 'sms', 'frequency' => $frequency ) );
                        }
                    }
                    
                    if( $template_present ) {
                        
                        wcap_update_notifications( 
                            $id, 
                            $sms_body, 
                            $frequency, 
                            $active, 
                            $coupon_code 
                        );
                    } else { 

                        $temp_id = wcap_insert_notifications( 
                            $sms_body, 
                            'sms', 
                            $active, 
                            $frequency, 
                            $coupon_code, 
                            $default_template 
                        );
                        
                        $insert = true;
                    }
                }
            }
            echo $insert;
            die();
            
        }
    } 
    $wcap_sms = new WCap_SMS();
}
