<?php


// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('Wcap_Abandoned_Cart_List' ) ) {
    
    class Wcap_Abandoned_Cart_List {

        
        public static function wcap_display_abandoned_cart_list( ){
            global $woocommerce, $wpdb;
            $duration_range = "";
            if ( isset( $_POST['duration_select'] ) ) {
                $duration_range = $_POST['duration_select'];
                $_SESSION['duration']   = $duration_range;
            }
            if ( '' == $duration_range && isset( $_GET['duration_select'] ) ) {
                $duration_range = $_GET['duration_select'];
                $_SESSION['duration']   = $duration_range;
            }
            if ( isset($_SESSION ['duration'] ) && '' != $_SESSION ['duration'] ){
                $duration_range = $_SESSION ['duration'];
            }
            if ( '' == $duration_range ) {
                $duration_range = "last_seven";
                $_SESSION['duration']   = $duration_range;
            }
            $wcap_ac_class  = new xcart_ap();

            $section = isset( $_GET[ 'wcap_section' ] ) ? $_GET[ 'wcap_section' ] : '';
            $display_trash_success = false;
            if ( isset( $_GET['wcap_section'], $_GET['wcap-trash-all'] ) && 'wcap_trash_abandoned' === $_GET['wcap_section'] && 'wcap-trash-all' === $_GET['wcap-trash-all'] ) {
                $trash_deleted = $wpdb->delete( WCAP_ABANDONED_CART_HISTORY_TABLE, array( 'wcap_trash' => '1' ) );

                $display_trash_success = true;
		$section = 'wcap_all_abandoned';
                $_GET['wcap_section'] = 'wcap_all_abandoned';
            }
            ?>
            <p>
                <?php _e( 'در لیست زیر شما سفارشات رها شده و جزییات هر سفارش را مشاهده می‌کنید', 'xcart-tr' ); ?>
                <br>
                
            </p>
            <style>
           
               
            </style>
            
           <?php
                
            if ( $section == 'wcap_trash_abandoned' ) {

                $wcap_abandoned_order_list = new Wcap_Abandoned_Orders_Table();
                $wcap_trash_abandoned_list = new Wcap_Abandoned_Trash_Orders_Table();
                $wcap_trash_abandoned_list->wcap_abandoned_order_prepare_items();
            } else {
                $wcap_abandoned_order_list = new Wcap_Abandoned_Orders_Table();
                $wcap_abandoned_order_list->wcap_abandoned_order_prepare_items();
            }

            $wcap_abandoned_order_list->wcap_abandoned_order_prepare_items();

            $get_all_abandoned_count      = $wcap_abandoned_order_list->total_all_count; 
            $get_trash_abandoned_count    = Wcap_Common::wcap_get_abandoned_order_count( 'wcap_trash_abandoned' );
            $get_registered_user_ac_count = $wcap_abandoned_order_list->total_registered_count; 
            $get_guest_user_ac_count      = $wcap_abandoned_order_list->total_guest_count; 
            $get_visitor_user_ac_count    = $wcap_abandoned_order_list->total_visitors_count; 
            $get_unsubscribe_carts_count    = Wcap_Common::wcap_get_abandoned_order_count( 'wcap_all_unsubscribe_carts' );
            $wcap_user_gus_text = $get_guest_user_ac_count > 1 ? __( 'کاربر', 'xcart-tr' ) : __( 'کاربر', 'xcart-tr' );

            $wcap_user_reg_text = $get_registered_user_ac_count > 1 ? __( 'کاربر', 'xcart-tr' ) : __( 'کاربر', 'xcart-tr' );                        

            $wcap_all_abandoned_carts  = $wcap_trash_abandoned = $wcap_all_registered = $wcap_all_guest = $wcap_all_visitor =  $wcap_all_unsubscribe_carts = "";
            
            switch( $section ) {
                case 'wcap_all_abandoned':
                    $wcap_all_abandoned_carts = "current";
		    break;
                case 'wcap_trash_abandoned':
                    $wcap_trash_abandoned = "current";
                    break;
                case 'wcap_all_registered':
                    $wcap_all_registered = "current";
                    break;
                case 'wcap_all_guest':
                    $wcap_all_guest = "current";
                    break;
                case 'wcap_all_visitor':
                    $wcap_all_visitor = "current";
                    break;
                case 'wcap_all_unsubscribe_carts':
                    $wcap_all_unsubscribe_carts = "current";
                    break;
                default:
                    $wcap_all_abandoned_carts = "current";
                    break;
            }

            ?>
	    <?php
            if ( $display_trash_success ) {
                ?>
                <div class="notice-success" id="trash-notice" style="background: #fff; text-align: left; border: 1px solid #ccd0d4; font-size: 14px; border-left-color: #46b450; border-left-width: 4px; margin: 5px 0 15px;">
                    <p style="padding-left: 15px;"> 
                    <?php
                    echo wp_kses_post(
                        sprintf(
                            __('', 'xcart-tr'),
                            esc_attr( $trash_deleted )
                        )
                    );
                    ?>
                    </p>
                </div>
            <?php
            }
            ?>
            <ul class="subsubsub" id="wcap_recovered_orders_list">
                <li>
                    <a href="admin.php?page=xcart&action=listcart&wcap_section=wcap_all_abandoned" class="<?php echo $wcap_all_abandoned_carts; ?>"><?php _e( "همه ", 'xcart-tr' );?> <span class = "count" > <?php echo "( $get_all_abandoned_count )" ?> </span></a>
                </li>

                <?php if( $get_trash_abandoned_count > 0 ) { ?>
                   <li>
                   | <a href="admin.php?page=xcart&action=listcart&wcap_section=wcap_trash_abandoned" class="<?php echo $wcap_trash_abandoned; ?>"><?php _e( "غیر فعال ", 'xcart-tr' );?> <span class = "count" > <?php echo "( $get_trash_abandoned_count )" ?> </a>
                </li>
                <?php } ?>

                <?php if( $get_registered_user_ac_count > 0 ) { ?>
                <li>
                    | <a href="admin.php?page=xcart&action=listcart&wcap_section=wcap_all_registered" class="<?php echo $wcap_all_registered; ?>"><?php _e( " کاربر سایت $wcap_user_reg_text ", 'xcart-tr' ) ;?> <span class = "تعداد" > <?php echo "( $get_registered_user_ac_count )" ?> </span></a>
                </li>
                <?php } ?>

                <?php if( $get_guest_user_ac_count > 0 ) { ?>
                <li>
                    | <a href="admin.php?page=xcart&action=listcart&wcap_section=wcap_all_guest" class="<?php echo $wcap_all_guest; ?>"><?php _e( " کاربر مهمان $wcap_user_gus_text ", 'xcart-tr' );?> <span class = "count" > <?php echo "( $get_guest_user_ac_count )" ?> </span></a>
                </li>
                <?php } ?>

                <?php if( $get_visitor_user_ac_count > 0 ) { ?>
                <li>
                    | <a href="admin.php?page=xcart&action=listcart&wcap_section=wcap_all_visitor" class="<?php echo $wcap_all_visitor; ?>"><?php _e( " سبد خرید بدون جزییات مشتری ", 'xcart-tr' );?> <span class = "count" > <?php echo "( $get_visitor_user_ac_count )" ?> </span></a>
                </li>
                <?php } ?>

                <?php if( $get_unsubscribe_carts_count > 0 ) { ?>
                <li>
                    | <a href="admin.php?page=xcart&action=listcart&wcap_section=wcap_all_unsubscribe_carts" class="<?php echo $wcap_all_unsubscribe_carts; ?>"><?php _e( " لغو شده ", 'xcart-tr' );?> <span class = "count" > <?php echo "( $get_unsubscribe_carts_count )" ?> </span></a>
                </li>
                <?php } ?>


            </ul>
            <br class="clear">
            <div id="wcap_ac_bulk_message" class="error">
                <p class="wcap_ac_bulk_message_p">
                    <strong>
                        <?php _e( "" ); ?>
                    </strong>
                </p>
            </div>
           
            <div class="wrap">
                <form id="wcap-abandoned-orders" method="get" >
                    <input type="hidden" name="page" value="xcart" />
                    <input type="hidden" name="action" value="listcart" />
                    <input type="hidden" name="wcap_action" value="listcart" />
                    <input type="hidden" name="wcap_section" value="<?php echo esc_attr( $section ); ?>" />

                    <?php
                        if( $section == 'wcap_trash_abandoned' ) {
                            $wcap_trash_abandoned_list->display();
                        } else { 
                            $wcap_abandoned_order_list->display(); 
                        }
                    ?>
                </form>
            </div>
        <?php

        }
    }
}
