<?php


if ( ! defined( 'ABSPATH' ) ) exit;



class Wcap_Advanced_Report_Action {

    
    function wcap_get_all_reports( $selected_data_range, $start_date, $end_date ){

        global $wpdb;

        include_once( 'dashboard_report.php' );
        
        $wcap_month_total_orders_amount   = $wcap_month_recovered_cart_amount = 0;
        $wcap_month_recovered_cart_count  = $wcap_month_abandoned_cart_count  = 0;
        $ratio_of_recovered_number        = 0;
        $wcap_month_wc_orders             = 0;
        $ratio_of_recovered               = 0;
        $ratio_of_total_vs_abandoned      = 0;
        $wcap_atc_data                    = array();
        $orders = new Wcap_Dashboard_Report();

        $wcap_month_total_orders_amount   = $orders->get_this_month_amount_reports( 'wc_total_sales' , $selected_data_range, $start_date, $end_date );
        $wcap_month_recovered_cart_amount = $orders->get_this_month_amount_reports( 'recover'        , $selected_data_range, $start_date, $end_date );

        
        if ( $wcap_month_total_orders_amount < 0 ){

            $wcap_month_total_orders_amount = 0 ;
        }
        if ( $wcap_month_recovered_cart_amount > 0 && $wcap_month_total_orders_amount > 0 ){
            $ratio_of_recovered            = ( $wcap_month_recovered_cart_amount / $wcap_month_total_orders_amount ) * 100;
            $ratio_of_recovered            = round( $ratio_of_recovered, wc_get_price_decimals() );
        }

        
        $stats = $orders->get_adv_stats( $selected_data_range, $start_date, $end_date );

        $wcap_month_abandoned_cart_count   = $stats['abandoned_count'];
        $wcap_month_recovered_cart_count   = $stats['recovered_count'];

        if ( $wcap_month_recovered_cart_count > 0 && $wcap_month_abandoned_cart_count > 0 ){
            $ratio_of_recovered_number     = ( $wcap_month_recovered_cart_count / $wcap_month_abandoned_cart_count ) * 100;
            $ratio_of_recovered_number     = round( $ratio_of_recovered_number, wc_get_price_decimals() );
        }

        $wcap_month_wc_orders              = $orders->get_this_month_total_vs_abandoned_order( 'wc_total_orders', $selected_data_range, $start_date, $end_date );

        if ( $wcap_month_abandoned_cart_count > 0 && $wcap_month_wc_orders > 0 ){
            $ratio_of_total_vs_abandoned   = ( $wcap_month_abandoned_cart_count / $wcap_month_wc_orders  ) * 100;
            $ratio_of_total_vs_abandoned   = round( $ratio_of_total_vs_abandoned, wc_get_price_decimals() );
        }

        $wcap_email_sent_count             = $orders->wcap_get_email_report( "total_sent", $selected_data_range, $start_date, $end_date );

        $wcap_email_opened_count           = $orders->wcap_get_email_report( "total_opened", $selected_data_range, $start_date, $end_date );

        $wcap_email_clicked_count          = $orders->wcap_get_email_report( "total_clicked", $selected_data_range, $start_date, $end_date );

        $wcap_atc_data                     = $orders->wcap_get_atc_data_of_range( $selected_data_range, $start_date, $end_date );

        $graph_data = $orders->get_abandoned_data( $selected_data_range, $start_date, $end_date );

        wp_localize_script(
            'wcap_graph_js', 
            'wcap_graph_data', 
            array(
                'data'   => $graph_data,
            ) 
        );

        wp_enqueue_script ( 'wcap_graph_js' );

    ?>
        <br>
      


        <?php
    }

    
    public function search_by_date(  ) {

        $this->duration_range_select = array(

            'this_month'   => __( 'این ماه'   , 'xcart-tr' ),
            'last_month'   => __( 'ماه گذشته'   , 'xcart-tr' ),
            
            'this_year'    => __( 'امسال'    , 'xcart-tr' ),
            'last_year'    => __( 'پارسال'    , 'xcart-tr' ),
            'other'        => __( 'انتخاب بازه زمانی'       , 'xcart-tr' ),
        );
        if ( isset( $_GET['duration_select'] ) ) {
            $duration_range = $_GET['duration_select'];
        }else{
            $duration_range = "this_month";
        }
        ?>
        <div class = "main_start_end_date" id = "main_start_end_date" >
            <div class = "filter_date_drop_down" id = "filter_date_drop_down" >
                <label class="date_time_filter_label" for="date_time_filter_label" >
                    <strong>
                        <?php _e( "انتخاب بازه زمانی", "xcart-tr"); ?>
                    </strong>
                </label>

                <select id=duration_select name="duration_select" >
                    <?php
                    foreach ( $this->duration_range_select as $key => $value ) {
                        $sel = "";
                        if ( $key == $duration_range ) {
                            $sel = __( "انتخاب ", "xcart-tr" );
                        }
                        echo"<option value='" . $key . "' $sel> " . __( $value,'xcart-tr' ) . " </option>";
                    }
                    ?>
                </select>
                <?php

                $start_date_range = "";
                if ( isset( $_GET['wcap_start_date'] ) ) {
                    $start_date_range = $_GET['wcap_start_date'];
                }

                $end_date_range = "";
                if ( isset( $_GET['wcap_end_date'] ) ){
                    $end_date_range = $_GET['wcap_end_date'];
                }
                $start_end_date_div_show = 'block';
                if ( !isset($_GET['duration_select']) || $_GET['duration_select'] != 'other' ) {
                    $start_end_date_div_show = 'none';
                }
                ?>

                <div class = "wcap_start_end_date_div" id = "wcap_start_end_date_div" style="display: <?php echo $start_end_date_div_show; ?>;"  >
                    <input type="text" id="wcap_start_date" name="wcap_start_date" readonly="readonly" value="<?php echo $start_date_range; ?>" placeholder="yyyy-mm-dd"/>
                    <input type="text" id="wcap_end_date" name="wcap_end_date" readonly="readonly" value="<?php echo $end_date_range; ?>" placeholder="yyyy-mm-dd"/>
                </div>
                <div id="wcap_submit_button" class="wcap_submit_button">
                    <?php submit_button( __( 'برو', 'xcart-tr' ), 'button', false, false, array('ID' => 'wcap-search-by-date-submit' ) ); ?>
                </div>
            </div>
        </div>

       <?php
    }
}
