<?php



if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

$rule_type_options = apply_filters(
	'wcap_rules_engine_rule_type_values',
	array(
		'select_disabled'  => __( 'Select Rule Type', 'xcart-tr' ),
		'coupons'          => __( 'Coupons', 'xcart-tr' ),
		'send_to'          => __( 'Send Emails to', 'xcart-tr' ),
		'order_disabled'   => __( 'Order', 'xcart-tr' ),
		'payment_gateways' => __( 'Payment Gateways', 'xcart-tr' ),
		'cart_disabled'    => __( 'Cart', 'xcart-tr' ),
		'cart_status'      => __( 'Cart Status', 'xcart-tr' ),
		'product_cat'      => __( 'Product Categories', 'xcart-tr' ),
		'product_tag'      => __( 'Product Tags', 'xcart-tr' ),
		'cart_items'       => __( 'Cart Items', 'xcart-tr' ),
		'cart_items_count' => __( 'Number of Cart Items', 'xcart-tr' ),
		'cart_total'       => __( 'Cart Total', 'xcart-tr' ),
	)
);

$rule_condition_options = apply_filters(
	'wcap_rules_engine_rule_condition_values',
	array(
		'select_disabled'       => __( 'Select Condition', 'xcart-tr' ),
		'includes'              => __( 'Includes any of', 'xcart-tr' ),
		'excludes'              => __( 'Excludes any of', 'xcart-tr' ),
		'greater_than_equal_to' => __( 'Greater than or equal to', 'xcart-tr' ),
		'equal_to'              => __( 'Equal to', 'xcart-tr' ),
		'less_than_equal_to'    => __( 'Less than or equal to', 'xcart-tr' ),
	)
);
?>
<td class='wcap_rule_type_col'>
	<select class='wcap_rule_type' id='wcap_rule_type_' name='wcap_rule_type_' onChange='wcap_rule_values( this.id )'>
	<?php
	foreach ( $rule_type_options as $type_key => $type_value ) {
		$disabled = '';
		$selected = 'select_disabled' === $type_key ? 'selected' : '';	
		if ( strpos( $type_key, 'disabled' ) !== false ) {
			$type_key = '';
			$disabled = 'disabled';
		}

		if ( in_array( $type_key, array( 'cart_status', 'payment_gateways', 'product_cat', 'product_tag', 'cart_items', 'cart_items_count', 'cart_total' ) ) ) {
			$type_value = '→ ' . $type_value;
			$class = 'wcap_rule_subcategory';
		} else {
			$class = 'wcap_rule_parent_category';
		}
		echo sprintf(
			"<option value='%s' %s %s class='%s'>%s</option>",
			esc_attr( $type_key ),
			esc_attr( $disabled ),
			esc_attr( $selected ),
			esc_attr( $class ),
			esc_html( $type_value )
		);
	}
	?>
	</select>
</td>
<td class='wcap_rule_condition_col'>
	<select class='wcap_rule_condition' id='wcap_rule_condition_' name='wcap_rule_condition_'>
		<?php
		foreach ( $rule_condition_options as $cond_key => $cond_value ) {
			$disabled = '';

			if ( strpos( $cond_key, 'disabled' ) !== false ) {
				$cond_key = '';
				$disabled = 'disabled';
			}
			echo sprintf(
				"<option value='%s' %s>%s</option>",
				esc_attr( $cond_key ),
				esc_attr( $disabled ),
				esc_html( $cond_value )
			);
		}
		?>
	</select>
</td>
<td class='wcap_rule_value_col'>
	<select class='wcap_rule_value' id='wcap_rule_value_' name='wcap_rule_value_'>
		<option value='' disabled selected><?php esc_html_e( 'Select values', 'xcart-tr' ); ?></option>
	</select>
</td>
<td>
	<a href='javascript:void(0)' class='wcap_delete_rule_button'>
		<i class='fa fa-trash fa-lg fa-fw' id='wcap_rule_delete_' onclick='wcap_delete_rule_row( this.id )'></i>
	</a>
	<a href='javascript:void(0)' class='wcap_add_rule_button' id='add_new' onclick='wcap_add_new_rule_row( this.id )'>
		<i class='fa fa-plus fa-lg fa-fw'></i>
		<?php echo esc_html__( 'Add Rule', 'xcart-tr' ); ?>
	</a>
</td>
