<?php
/*
* Plugin Name: XCart
* Plugin URI: pournasir.com
* Description: جهشی متفاوت در فروش آنلاین خود حس کنید. ایکس‌کارت افزایش دهنده ۱۰۰٪ خرید‌های موفق شما. رفتن به بخش  <strong>ووکامرس -> <a href="admin.php?page=xcart">Xcart</a> </strong>
* Version: 1.1.0
* Author URI: http://www.pournasir.com/
* Text Domain: xcart
* Requires PHP: 5.6
* WC requires at least: 3.0.0
* WC tested up to: 4.5.2
*
* @package Xcart
*/
global $ACUpdateChecker;
$ACUpdateChecker = '1.0.0';
define('EDD_SL_ITEM_NAME_AC_WOO', 'XCart');
require_once("includes/main/x_activate_plugin.php");
require_once("includes/main/x_update_check.php");
require_once("includes/main/x_default_settings.php");

if ( ! class_exists('xcart_ap')) {
    class xcart_ap
    {
        public $one_hour;

        public $three_hours;

        public $six_hours;

        public $twelve_hours;

        public $one_day;

        public $one_week;

        public $duration_range_select = array();

        public $start_end_dates = array();

        public function __construct()
        {
            $this->wcap_declare_variable();
            add_action('plugins_loaded', array(&$this, 'wcap_load_files'), 5);
            register_activation_hook(__FILE__, array('Wcap_Activate_Plugin', 'wcap_activate'));
            register_deactivation_hook(__FILE__, array(&$this, 'wcap_deactivate'));
            add_action('plugins_loaded', array(&$this, 'wcap_load_hooks'), 6);
        }

        function wcap_declare_variable()
        {
            $this->one_hour = 60 * 60;
            $this->three_hours = 3 * $this->one_hour;
            $this->six_hours = 6 * $this->one_hour;
            $this->twelve_hours = 12 * $this->one_hour;
            $this->one_day = 24 * $this->one_hour;
            $this->one_week = 7 * $this->one_day;
            $this->duration_range_select = array(
                'yesterday'      => __('دیورز', 'xcart-tr'),
                'today'          => __('امروز', 'xcart-tr'),
                'last_seven'     => __('۷ روز گذشته', 'xcart-tr'),
                'last_fifteen'   => __('۱۵ روز گذشته', 'xcart-tr'),
                'last_thirty'    => __('۳۰ روز گذشته', 'xcart-tr'),
                'last_ninety'    => __('۹۰ روز گذشته', 'xcart-tr'),
                'last_year_days' => __('۱ سال گذشته', 'xcart-tr'),
            );

            $this->start_end_dates = array(
                'yesterday' => array(
                    'start_date' => date("d M Y", (current_time('timestamp') - 24 * 60 * 60)),
                    'end_date'   => date("d M Y", (current_time('timestamp') - 7 * 24 * 60 * 60)),
                ),

                'today' => array(
                    'start_date' => date("d M Y", (current_time('timestamp'))),
                    'end_date'   => date("d M Y", (current_time('timestamp'))),
                ),

                'last_seven' => array(
                    'start_date' => date("d M Y", (current_time('timestamp') - 7 * 24 * 60 * 60)),
                    'end_date'   => date("d M Y", (current_time('timestamp'))),
                ),

                'last_fifteen' => array(
                    'start_date' => date("d M Y", (current_time('timestamp') - 15 * 24 * 60 * 60)),
                    'end_date'   => date("d M Y", (current_time('timestamp'))),
                ),

                'last_thirty' => array(
                    'start_date' => date("d M Y", (current_time('timestamp') - 30 * 24 * 60 * 60)),
                    'end_date'   => date("d M Y", (current_time('timestamp'))),
                ),

                'last_ninety' => array(
                    'start_date' => date("d M Y", (current_time('timestamp') - 90 * 24 * 60 * 60)),
                    'end_date'   => date("d M Y", (current_time('timestamp'))),
                ),

                'last_year_days' => array(
                    'start_date' => date(
                        "d M Y",
                        (current_time('timestamp') - 365 * 24 * 60 * 60)
                    ),
                    'end_date'   => date("d M Y", (current_time('timestamp'))),
                ),
            );

            self::wcap_define_constants_for_table_and_other();
        }

        public static function wcap_define_constants_for_table_and_other()
        {
            global $wpdb;

            if ( ! defined('WCAP_PLUGIN_VERSION')) {
                define('WCAP_PLUGIN_VERSION', "8.9.0");
            }

            if ( ! defined('WCAP_ABANDONED_CART_HISTORY_TABLE')) {
                define('WCAP_ABANDONED_CART_HISTORY_TABLE', $wpdb->prefix."xcart_ac_history");
            }

            if ( ! defined('WCAP_GUEST_CART_HISTORY_TABLE')) {
                define('WCAP_GUEST_CART_HISTORY_TABLE', $wpdb->prefix."xcart_guest_ac_history");
            }

            if ( ! defined('WCAP_EMAIL_TEMPLATE_TABLE')) {
                define('WCAP_EMAIL_TEMPLATE_TABLE', $wpdb->prefix."xcart_et");
            }

            if ( ! defined('WCAP_EMAIL_CLICKED_TABLE')) {
                define('WCAP_EMAIL_CLICKED_TABLE', $wpdb->prefix."xcart_link_clicked_email");
            }

            if ( ! defined('WCAP_EMAIL_OPENED_TABLE')) {
                define('WCAP_EMAIL_OPENED_TABLE', $wpdb->prefix."xcart_om");
            }

            if ( ! defined('WCAP_EMAIL_SENT_HISTORY_TABLE')) {
                define('WCAP_EMAIL_SENT_HISTORY_TABLE', $wpdb->prefix."xcart_sent");
            }

            if ( ! defined('WCAP_PLUGIN_FILE')) {
                define('WCAP_PLUGIN_FILE', __FILE__);
            }

            if ( ! defined('WCAP_PLUGIN_URL')) {
                define('WCAP_PLUGIN_URL', untrailingslashit(plugins_url('/', __FILE__)));
            }

            if ( ! defined('WCAP_ADMIN_URL')) {
                define('WCAP_ADMIN_URL', admin_url('admin.php'));
            }

            if ( ! defined('WCAP_ADMIN_AJAX_URL')) {
                define('WCAP_ADMIN_AJAX_URL', admin_url('admin-ajax.php'));
            }

            if ( ! defined('WCAP_PLUGIN_PATH')) {
                define('WCAP_PLUGIN_PATH', untrailingslashit(plugin_dir_path(__FILE__)));
            }

            if ( ! defined('WCAP_NOTIFICATIONS')) {
                define('WCAP_NOTIFICATIONS', $wpdb->prefix."xcart_notifications");
            }

            if ( ! defined('WCAP_NOTIFICATIONS_META')) {
                define('WCAP_NOTIFICATIONS_META', $wpdb->prefix."xcart_actionscheduler_claims");
            }

            if ( ! defined('WCAP_TINY_URLS')) {
                define('WCAP_TINY_URLS', $wpdb->prefix."xcart_shortlink");
            }
        }

        public static function wcap_load_files()
        {
            global $pagenow;

            require_once("includes/admin/edd.php");
            require_once("includes/x_hooks.php");
            require_once("includes/main/x_scripts.php");
            require_once('includes/admin/orders-listing.php');        
            require_once("includes/x_common.php");
            require_once("includes/functions.php");
            require_once('includes/main/x-email-functions.php');
            require_once("includes/ajax.php");
            require_once('includes/main/x_process.php');
            require_once("includes/admin/actions_handler.php");
            require_once('includes/webhooks.php');
            require_once("includes/main/x_db_layer.php");
            require_once('includes/admin/sms_reminders.php');
            require_once('includes/admin/sms_settings.php');

            $is_admin = is_admin();

            if (true === $is_admin) {
                    require_once("includes/admin/menu.php");
                    require_once("includes/admin/xcart-details.php");
                    require_once('includes/admin/export.php');
                    require_once('includes/admin/delete.php');
                    
            }

            if (true === $is_admin && (
                    (isset($_GET['page']) && "xcart" === $_GET['page']) ||
                    (isset($_POST['option_page']) &&
                        ('woocommerce_ac_settings' === $_POST['option_page'] ||
                            'woocommerce_ac_license' === $_POST['option_page'] ||
                            'woocommerce_sms_settings' === $_POST['option_page'])
                    )
                )
            ) {
                self::wcap_load_admin_side_files();

                self::wcap_load_support_class_files();
            } elseif (true === $is_admin && ('index.php' === $pagenow || 'admin-ajax.php' === $pagenow)) {
                self::wcap_load_dashboard_widget_files();
            }

            if (false === $is_admin) {
                self::wcap_load_front_side_files();
            }

            require_once("includes/classes/aes.php");
            require_once("includes/classes/aes_ctr.php");

            require_once("includes/admin/admin_recovery.php");

            $wcap_auto_cron = get_option('wcap_use_auto_cron');
            if (isset($wcap_auto_cron) && $wcap_auto_cron != false && '' != $wcap_auto_cron) {
                require_once("includes/cron.php");
            }

            include_once(ABSPATH.'wp-admin/includes/plugin.php');
            if (is_plugin_active('woocommerce-aelia-currencyswitcher/woocommerce-aelia-currencyswitcher.php')) {
                require_once("includes/cs.php");
            }

            require_once('includes/component/tracking-data/class-ts-tracker.php');
            require_once("includes/component/woocommerce-check/ts-woo-active.php");
            require_once("includes/component/tracking-data/ts-tracking.php");

            require_once("includes/x_all_component.php");
            require_once('includes/main/x_verification.php');

            do_action('wcap_after_load_files');
        }

        public static function wcap_load_admin_side_files()
        {
            require_once("includes/admin/add_settings.php");
            require_once("includes/admin/actions.php");
			require_once("includes/admin/display_notices.php");
            require_once("includes/admin/email_settings.php");
            require_once("includes/admin/dashboard.php");
            require_once("includes/admin/dashboard_advanced.php");
            require_once("includes/admin/xcart_list.php");
            require_once("includes/admin/class-wcap-email-template-list.php");
            require_once("includes/admin/tiny_mce.php");
            require_once("includes/admin/wcap_localization.php");
            require_once("includes/admin/popup_modal.php");
        }

        public static function wcap_load_front_side_files()
        {
            require_once("includes/frontend/cart_updated.php");
            require_once("includes/frontend/order_received.php");
            require_once("includes/frontend/populate_cart_of_user.php");
            require_once("includes/frontend/on_placed_order.php");
            require_once("includes/frontend/coupon_code.php");
            require_once('includes/frontend/class-tracking-msg.php');
            require_once('includes/main/x_shortlink.php');
        }

        public static function wcap_load_support_class_files()
        {
            require_once("includes/classes/manual_email.php");
            require_once("includes/classes/send-manual-email.php");
            require_once("includes/classes/dashboard_report_action.php");
            require_once("includes/classes/dashboard_adv_report_action.php");
            require_once("includes/classes/abandoned_orders_table.php");
            require_once("includes/classes/abandoned_trash_orders_table.php");
            require_once("includes/classes/templates_table.php");
            require_once("includes/classes/sent_emails_table.php");
            require_once("includes/classes/product_report_table.php");
            require_once("includes/classes/atc_dashboard.php");
            require_once('includes/classes/sms_templates_table.php');
            require_once('includes/classes/sent_sms_table.php');
        }

        public static function wcap_load_dashboard_widget_files()
        {
            require_once("includes/classes/dashboard_widget_report.php");
            require_once("includes/classes/dashboard_widget_heartbeat.php");
        }
        
        
        static function wcap_load_hooks()
        {
            Wcap_Load_Hooks::wcap_load_hooks_and_filters();
            do_action('wcap_after_load_hooks');
            
        }

        function wcap_deactivate()
        {
            if (false !== as_next_scheduled_action('woocommerce_ac_send_email_action')) {
                as_unschedule_action('woocommerce_ac_send_email_action');
            }
        }
    }
}

$xcart = new xcart_ap();
?>
